// interface setup

#include "main.h"

// local prototypes
uint8_t select(char * msg, char * Choices, uint8_t numChoices, uint8_t preSelect);

void Setup(void)
{
uint8_t a,defa;
uint8_t restoreLocal;
	restoreLocal = stLocal;
	stLocal = FALSE;
	LOCAL_LED_OFF;
	UART1_sendChar(LOCAL_OFF);

	UART1_sendChar(ENEWLINE);
	BoldFlag = TRUE; UnderlineFlag = TRUE;
	printString("Interface Setup\n");
	BoldFlag = FALSE; UnderlineFlag = FALSE;
	UART1_sendChar(ENEWLINE);
// baud rate
	defa = 2;
    a = eeprom_read_byte(&BaudSetting);
	if ((a < 1) || (a > 3)) a = defa;	// default value
	a = select("Baud Rate:","(1) = 1200      (2) = 9600      (3) = 115200",3,a);
	eeprom_update_byte(&BaudSetting,a);	// write new setting to EEPROM
// handshake
	defa = 1;
    a = eeprom_read_byte(&ProtocolSetting);
	if ((a < 1) || (a > 3)) a = defa;	// default value
	a = select("Protocol:","(1) = None      (2) = XON/XOFF  (3) = Hardware",3,a);
	eeprom_update_byte(&ProtocolSetting,a);	// write new setting to EEPROM
// charset translation
	defa = 1;
    a = eeprom_read_byte(&Translation);
	if ((a < 1) || (a > 2)) a = defa;	// default value
	a = select("Charset Translation:","(1) = ASCII     (2) = RAW",2,a);
	eeprom_update_byte(&Translation,a);	// write new setting to EEPROM
// following options only in ASCII mode
	if (a == 1) {		
		// CR from Host Translation:
		defa = 1;
	    a = eeprom_read_byte(&CRfromHost);
		if ((a < 1) || (a > 2)) a = defa;	// default value
		a = select("CR from Host Translation:","(1) = CR        (2) = CR LF",2,a);
		eeprom_update_byte(&CRfromHost,a);	// write new setting to EEPROM
		// CR to Host Translation:
		defa = 1;
	    a = eeprom_read_byte(&CRtoHost);
		if ((a < 1) || (a > 2)) a = defa;	// default value
		a = select("CR to Host Translation:","(1) = CR        (2) = CR LF",2,a);
		eeprom_update_byte(&CRtoHost,a);	// write new setting to EEPROM
	}	// end of CR translation section
	UART1_sendChar(ENEWLINE);
	printString("**** End of Interface Setup ****");
	UART1_sendChar(ENEWLINE);

	SetupToggle = FALSE;
	stLocal = restoreLocal;
	if (stLocal) {
		LOCAL_LED_ON;
		UART1_sendChar(LOCAL_ON);
	}
	else {
		LOCAL_LED_OFF;
		UART1_sendChar(LOCAL_OFF);
	}
}	// end of Setup


uint8_t select(char * msg, char * Choices, uint8_t numChoices, uint8_t preSelect)
{
uint8_t a,c,i;
	UART1_sendChar(ENEWLINE);
	BoldFlag = TRUE;
	printString(msg);
	BoldFlag = FALSE;
	UART1_sendChar(ENEWLINE);
	
	printString(Choices);
	UART1_sendChar(ENEWLINE);
	for (i=0;i<((preSelect-1)*16);i++) printChar(' ');
	printString(" ^--");
	UART1_sendChar(ENEWLINE);
	printString("press 1 to ");
	printChar('0' + numChoices);
	printString(" to select, or 0 for no change: ");
	do {
		while (!keyBufUsage) { }
		cli();
		c = keyBuf[keyOutPtr++];
		a = revtrans[c];		// translate to ASCII
		keyBufUsage--;
		sei();
	} while (a-'0' > numChoices); // wait for a valid key
	printChar(a);
	UART1_sendChar(ENEWLINE);
	if (a == '0') a = preSelect + '0';	// keep old choice if 0 was pressed
	return a-'0';
}	// end of select
